package com.example.ardubotrc_control;

import android.graphics.Point;
import android.util.Log;
import android.view.MotionEvent;
import android.view.View;
import android.view.View.OnTouchListener;
import android.widget.FrameLayout;

public class GameControls implements OnTouchListener{

	public Point _joystickOrigin = new Point();
	public Point _controlPosition = new Point();
	public Point _touchingPoint = new Point(225,167);
	public Point touchOffset = new Point(0,0);
	
	private Boolean _dragging = false;
	
	@Override
	public boolean onTouch(View v, MotionEvent event) {

		update(event);
		return true;
	}

	private MotionEvent lastEvent;
	public void update(MotionEvent event){

		if (event == null && lastEvent == null)
		{
			return;
		}else if(event == null && lastEvent != null){
			event = lastEvent;
		}else{
			lastEvent = event;
		}
		//drag drop 
		if ( event.getAction() == MotionEvent.ACTION_DOWN ){
			_dragging = true;
		}else if ( event.getAction() == MotionEvent.ACTION_UP){
			_dragging = false;
		}
		

		if ( _dragging ){
			// get the pos
			_touchingPoint.x = (int)event.getX() - touchOffset.x;
			_touchingPoint.y = (int)event.getY() - touchOffset.y;
			//Log.d("Event-Pos",Integer.toString((int)event.getX()) +" x " +Integer.toString((int)event.getY()));
		}else if (!_dragging)
		{
			// Snap back to center when the joystick is released
			_touchingPoint.x = _joystickOrigin.x;
			_touchingPoint.y = _joystickOrigin.y;
			//shaft.alpha = 0;
		}
	}
}
